package cn.lihongjie.coal.meter.controller;

import cn.lihongjie.coal.annotation.OrgScope;
import cn.lihongjie.coal.annotation.SysLog;
import cn.lihongjie.coal.base.dto.CommonQuery;
import cn.lihongjie.coal.base.dto.IdRequest;
import cn.lihongjie.coal.meter.dto.CreateMeterDto;
import cn.lihongjie.coal.meter.dto.MeterDto;
import cn.lihongjie.coal.meter.dto.UpdateMeterDto;
import cn.lihongjie.coal.meter.service.MeterService;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/meter")
@SysLog(module = "水电表管理")
@Slf4j
@OrgScope
public class MeterController {
    @Autowired private MeterService service;

    @PostMapping("/create")
    public MeterDto create(@RequestBody CreateMeterDto request) {
        return this.service.create(request);
    }

    @PostMapping("/update")
    public MeterDto update(@RequestBody UpdateMeterDto request) {
        return this.service.update(request);
    }

    @PostMapping("/delete")
    public Object delete(@RequestBody IdRequest request) {
        this.service.delete(request);
        return true;
    }

    @PostMapping("/getById")
    public MeterDto getById(@RequestBody IdRequest request) {
        return this.service.getById(request.getId());
    }

    @PostMapping("/list")
    public Page<MeterDto> list(@RequestBody CommonQuery request) {
        return this.service.list(request);
    }
}
